#include <stdio.h>

#include "wiringPi.h"
#include "sr595.h"

#include "sequence.h"

#define PIN_BASE 100
#define PIN_DATA 23
#define PIN_CLOCK 24
#define PIN_LATCH 25

#define PWM_LOOPS 8

int main() {
	int rc;

	rc = wiringPiSetupGpio();
	if (rc != 0) {
		printf("Error setting up wiringPi");
		return rc;
	}

	rc = sr595Setup(PIN_BASE, LEDS, PIN_DATA, PIN_CLOCK, PIN_LATCH);
	if (rc != 0) {
		printf("Error setting up sr595");
		return rc;
	}

	for (;;) {
		for (int frame = 0; frame < FRAMES; frame++) {
			for (int loop = 0; loop < PWM_LOOPS; loop++) {
				for (int level = 0; level < 7; level++) {
					for (int led = 0; led < LEDS; led++) {
						digitalWrite(PIN_BASE + led,
								frames[frame][led] > level ? 1 : 0);
					}
				}
			}
		}
	}

	return 0;
}
