#!/bin/bash

PIN_RED=17
PIN_YELLOW=27
PIN_GREEN=22
PIN_BUTTON=4

PULSE=0.5

# Initialization

gpio -g mode $PIN_RED out
gpio -g mode $PIN_YELLOW out
gpio -g mode $PIN_GREEN out

gpio -g mode $PIN_BUTTON in


function gpio_write
{
    local pin=$1
    local value=$2

    gpio -g write $pin $value
}

function sleepPulses
{
    local pulses=$1
    local seconds=$(echo "$pulses * $PULSE" | bc)
    sleep $seconds
}

function green
{
    gpio_write $PIN_RED 0
    gpio_write $PIN_YELLOW 0

    gpio_write $PIN_GREEN 1

    gpio -g wfi $PIN_BUTTON rising
}

function green_blink
{
    for i in $(seq 1 4)
    do
        gpio_write $PIN_GREEN 0
        sleepPulses 1
        gpio_write $PIN_GREEN 1
        sleepPulses 1
    done
}

function yellow
{
    gpio_write $PIN_GREEN 0
    gpio_write $PIN_YELLOW 1
    sleepPulses 4
}

function red
{
    gpio_write $PIN_YELLOW 0
    gpio_write $PIN_RED 1
    sleepPulses 8
}

function red_yellow
{
    gpio_write $PIN_RED 1
    gpio_write $PIN_YELLOW 1
    sleepPulses 4
}

while true
do
    green
    green_blink
    yellow
    red
    red_yellow
done
